__gnu_cxx::bitmap_allocator< typename > Class Template Reference
Allocators
Inheritance diagram for __gnu_cxx::bitmap_allocator< typename >:
[legend]

## Public Types

typedef free_list::__mutex_type | __mutex_type
typedef const _Tp * | const_pointer
typedef const _Tp & | const_reference
typedef ptrdiff_t | difference_type
typedef _Tp * | pointer
typedef std::true_type | propagate_on_container_move_assignment
typedef _Tp & | reference
typedef size_t | size_type
typedef _Tp | value_type

## Public Member Functions

| bitmap_allocator (const bitmap_allocator &) noexcept
template<typename _Tp1 >
| bitmap_allocator (const bitmap_allocator< _Tp1 > &) noexcept
pointer | _M_allocate_single_object () throw (std::bad_alloc)
void | _M_deallocate_single_object (pointer __p) throw ()
pointer | address (reference __r) const noexcept
const_pointer | address (const_reference __r) const noexcept
pointer | allocate (size_type __n)
pointer | allocate (size_type __n, typename bitmap_allocator< void >::const_pointer)
template<typename _Up , typename... _Args>
void | construct (_Up *__p, _Args &&...__args)
void | deallocate (pointer __p, size_type __n) throw ()
template<typename _Up >
void | destroy (_Up *__p)
size_type | max_size () const noexcept

## Private Types

typedef vector_type::iterator | iterator
typedef __detail::__mini_vector < value_type > | vector_type

## Private Member Functions

void | _M_clear ()
size_t * | _M_get (size_t __sz) throw (std::bad_alloc)
void | _M_insert (size_t *__addr) throw ()

## Detailed Description

### template<typename>
class __gnu_cxx::bitmap_allocator< typename >

Bitmap Allocator, primary template.

Definition at line 70 of file ext/alloc_traits.h.

## Member Function Documentation

template<typename >

pointer __gnu_cxx::bitmap_allocator< typename >::_M_allocate_single_object | ( |  | ) | throw (std::bad_alloc)

inline

Allocates memory for a single object of size sizeof(_Tp).

Exceptions

  std::bad_alloc. | If memory can not be allocated.

Complexity: Worst case complexity is O(N), but that is hardly ever hit. If and when this particular case is encountered, the next few cases are guaranteed to have a worst case complexity of O(1)! That's why this function performs very well on average. You can consider this function to have a complexity referred to commonly as: Amortized Constant time.

Definition at line 827 of file bitmap_allocator.h.

References __gnu_cxx::__detail::__bit_allocate(), __gnu_cxx::__detail::__num_bitmaps(), and __gnu_cxx::_Bit_scan_forward().

template<typename >

void __gnu_cxx::bitmap_allocator< typename >::_M_deallocate_single_object | ( | pointer | __p | ) | throw ()

inline

Deallocates memory that belongs to a single object of size sizeof(_Tp).

Complexity: O(lg(N)), but the worst case is not hit often! This is because containers usually deallocate memory close to each other and this case is handled in O(1) time by the deallocate function.

Definition at line 917 of file bitmap_allocator.h.

References __gnu_cxx::__detail::__bit_free(), __gnu_cxx::__detail::__num_bitmaps(), std::__rotate(), and __gnu_cxx::free_list::_M_insert().

The documentation for this class was generated from the following files:

- ext/alloc_traits.h
- bitmap_allocator.h